
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class AssetsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const assets = await db.assets.create(
            {
                id: data.id || undefined,
        
        name: data.name
        ||
        null
            ,
            
        asset_type: data.asset_type
        ||
        null
            ,
            
        status: data.status
        ||
        null
            ,
            
        asset_code: data.asset_code
        ||
        null
            ,
            
        address: data.address
        ||
        null
            ,
            
        purchase_price: data.purchase_price
        ||
        null
            ,
            
        purchase_date: data.purchase_date
        ||
        null
            ,
            
        current_valuation: data.current_valuation
        ||
        null
            ,
            
        valuation_date: data.valuation_date
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await assets.setCompany( data.company || null, {
            transaction,
        });
        
        await assets.setBusiness_unit( data.business_unit || null, {
            transaction,
        });
        

        
        await assets.setTags(data.tags || [], {
            transaction,
        });
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.assets.getTableName(),
                belongsToColumn: 'photos',
                belongsToId: assets.id,
            },
            data.photos,
            options,
        );
        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.assets.getTableName(),
                belongsToColumn: 'documents',
                belongsToId: assets.id,
            },
            data.documents,
            options,
        );
        

        return assets;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const assetsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                name: item.name
            ||
            null
            ,
            
                asset_type: item.asset_type
            ||
            null
            ,
            
                status: item.status
            ||
            null
            ,
            
                asset_code: item.asset_code
            ||
            null
            ,
            
                address: item.address
            ||
            null
            ,
            
                purchase_price: item.purchase_price
            ||
            null
            ,
            
                purchase_date: item.purchase_date
            ||
            null
            ,
            
                current_valuation: item.current_valuation
            ||
            null
            ,
            
                valuation_date: item.valuation_date
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const assets = await db.assets.bulkCreate(assetsData, { transaction });

        // For each item created, replace relation files
        
        for (let i = 0; i < assets.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.assets.getTableName(),
                    belongsToColumn: 'photos',
                    belongsToId: assets[i].id,
                },
                data[i].photos,
                options,
            );
        }
        
        for (let i = 0; i < assets.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.assets.getTableName(),
                    belongsToColumn: 'documents',
                    belongsToId: assets[i].id,
                },
                data[i].documents,
                options,
            );
        }
        

        return assets;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const assets = await db.assets.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.name !== undefined) updatePayload.name = data.name;
        
        
        if (data.asset_type !== undefined) updatePayload.asset_type = data.asset_type;
        
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        if (data.asset_code !== undefined) updatePayload.asset_code = data.asset_code;
        
        
        if (data.address !== undefined) updatePayload.address = data.address;
        
        
        if (data.purchase_price !== undefined) updatePayload.purchase_price = data.purchase_price;
        
        
        if (data.purchase_date !== undefined) updatePayload.purchase_date = data.purchase_date;
        
        
        if (data.current_valuation !== undefined) updatePayload.current_valuation = data.current_valuation;
        
        
        if (data.valuation_date !== undefined) updatePayload.valuation_date = data.valuation_date;
        
        
        updatePayload.updatedById = currentUser.id;

        await assets.update(updatePayload, {transaction});

        
        
        if (data.company !== undefined) {
            await assets.setCompany(
              
              data.company,
              
              { transaction }
            );
        }
        
        if (data.business_unit !== undefined) {
            await assets.setBusiness_unit(
              
              data.business_unit,
              
              { transaction }
            );
        }
        

        
        
        if (data.tags !== undefined) {
            await assets.setTags(data.tags, { transaction });
        }
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.assets.getTableName(),
                belongsToColumn: 'photos',
                belongsToId: assets.id,
            },
            data.photos,
            options,
        );
        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.assets.getTableName(),
                belongsToColumn: 'documents',
                belongsToId: assets.id,
            },
            data.documents,
            options,
        );
        

        return assets;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const assets = await db.assets.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of assets) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of assets) {
                await record.destroy({transaction});
            }
        });


        return assets;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const assets = await db.assets.findByPk(id, options);

        await assets.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await assets.destroy({
            transaction
        });

        return assets;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const assets = await db.assets.findOne(
            { where },
            { transaction },
        );

        if (!assets) {
            return assets;
        }

        const output = assets.get({plain: true});

        
        
        
        
        
        
        
        
        
        output.leases_asset = await assets.getLeases_asset({
            transaction
        });
        
        
        output.work_orders_asset = await assets.getWork_orders_asset({
            transaction
        });
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.company = await assets.getCompany({
            transaction
        });
        
        
        output.business_unit = await assets.getBusiness_unit({
            transaction
        });
        
        
        output.photos = await assets.getPhotos({
            transaction
        });
        
        
        output.documents = await assets.getDocuments({
            transaction
        });
        
        
        output.tags = await assets.getTags({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userCompanies = (user && user.companies?.id) || null;
        

        
        if (userCompanies) {
            if (options?.currentUser?.companiesId) {
                where.companiesId = options.currentUser.companiesId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.companies,
        as: 'company',
        
      },

      {
        model: db.business_units,
        as: 'business_unit',
        
        where: filter.business_unit ? {
          [Op.or]: [
            { id: { [Op.in]: filter.business_unit.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.business_unit.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },


      {
        model: db.tags,
        as: 'tags',
        required: false,
      },


      {
        model: db.file,
        as: 'photos',
      },

      {
        model: db.file,
        as: 'documents',
      },

    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'assets',
                        'name',
                        filter.name,
                    ),
                };
            }
            
            if (filter.asset_code) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'assets',
                        'asset_code',
                        filter.asset_code,
                    ),
                };
            }
            
            if (filter.address) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'assets',
                        'address',
                        filter.address,
                    ),
                };
            }
            

            
            

            
            if (filter.purchase_priceRange) {
                const [start, end] = filter.purchase_priceRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    purchase_price: {
                    ...where.purchase_price,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    purchase_price: {
                    ...where.purchase_price,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.purchase_dateRange) {
                const [start, end] = filter.purchase_dateRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    purchase_date: {
                    ...where.purchase_date,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    purchase_date: {
                    ...where.purchase_date,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.current_valuationRange) {
                const [start, end] = filter.current_valuationRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    current_valuation: {
                    ...where.current_valuation,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    current_valuation: {
                    ...where.current_valuation,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.valuation_dateRange) {
                const [start, end] = filter.valuation_dateRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    valuation_date: {
                    ...where.valuation_date,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    valuation_date: {
                    ...where.valuation_date,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.asset_type) {
                where = {
                    ...where,
                asset_type: filter.asset_type,
            };
            }
            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            


      
      if (filter.company) {
        const listItems = filter.company.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          companyId: {[Op.or]: listItems}
        };
      }
      

      


      if (filter.tags) {
        const searchTerms = filter.tags.split('|');

        include = [
          {
            model: db.tags,
            as: 'tags_filter',
            required: searchTerms.length > 0,
            where: searchTerms.length > 0 ? {
              [Op.or]: [
                { id: { [Op.in]: searchTerms.map(term => Utils.uuid(term)) } },
                { 
                  name: {
                    [Op.or]: searchTerms.map(term => ({ [Op.iLike]: `%${term}%` }))
                  }
                }
              ]
            } : undefined
          },
          ...include,
        ]
      }


            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.companiesId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.assets.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'assets',
                        'name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.assets.findAll({
            attributes: [ 'id', 'name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.name,
        }));
    }

    
};

